( 3iPiano.fs for 4x4 ports - AE - 2020-11-22---Sun---13:57 )

\ RECEIVE BUTTON PRESSES
: in4   11 10 9 8 ;  \ pins for input port, lsb on top of stack (8) 
12 constant CTRL-IN
\ SIGNAL LEDs
: out4  5 4 3 2 ;    \ pins for output port, lsb top of stack (2)

: init-piano
    out4 use-port-out 500 ms
    in4 port4in 500 ms
    2 piano-flash-n
    start-speaker
    ." OK" cr ;

$1B constant CALL_POLLPIANOKEY

: pollpianokey ( -- key ) \ wait till key is pressed.  
\ Uses new Nano instruction to fix problem that button 0 appears to be pressed falsely due to control line not being checked
    REG_PORTIN xstore CTRL-IN xstore CALL_POLLPIANOKEY xcall
    begin 1 read-com until rcv-buffer c@ not4 ;  \ BLOCKING READ  \ uses not4 for active low

: loop-pollpianokey ( -- ) begin pollpianokey . 50 ms until ;
    
: prompt-light-test ( idx -- ) 
    dup piano-led-map + c@ _light_
    pollpianokey = if ." Match!" else ." Wrong!" then ;
    
: prompt-light-trial ( idx -- )   \ 0 indexed buttons
    cr dup . ." : " 
    begin dup dup __  ." __ "\  __
    pollpianokey 110 ms dup . = until drop ." Done!" ;  \ pause waits for sound to play

: prompt-light ( idx -- )   \ 0 indexed buttons
    begin dup dup __ pollpianokey 100 ms = until drop ;  \ pause waits for sound to play

: scale-light ( # -- )  \ 1 indexed buttons
    #_ prompt-light ;

\ CODE REVIEW: Get to a musical data structure -- 3 arrays
\ play directly from stack, in reverse order
: play ( n -- ) dup 0 do dup i - roll .. loop drop ; \ NEW METHOD - WORKS (uses roll)
: watch ( n -- ) dup 0 do dup i - roll #__ 500 ms light| 100 ms loop drop light| ; \ 
: learn ( n -- ) dup 0 do dup i - roll scale-light 150 ms loop drop light| ; \ 

\ ========================================
: help-piano
  cr
  cr ." HELP-PIANO"
  cr ." ----------"
  cr 
  cr ." include 3iForth.fs 3iPort-4x4.fs 3iSound-4x4.fs 3iPiano.fs 3iPlaylist.fs "
  cr 
  cr ." 1 open-com"
  cr ." INIT-PIANO"
  cr ." press buttons for sound"
  cr ." press C for toggle between equitemper (c std), bhairav (indian) and yu (chinese scales)"
  cr
;

\ VERSION 1 - AE - 2020-11-22---Sun---14:37 - finished wiring the new PCB boards, including fixes with underneath
\ VERSION 2 - AE - 2020-11-27---Fri---20:02 - finished teach/learn mode
\ VERSION 3 - AE - 2020-11-28---Sat---21:34 - extended modes to play, watch, learn modes, including sharps and flats on numbers
